﻿Imports XafariWizardTest2.Module.ORMDataModel1
Imports Microsoft.VisualBasic
Imports System
Imports System.Linq
Imports System.Text
Imports DevExpress.ExpressApp
Imports DevExpress.Data.Filtering
Imports System.Collections.Generic
Imports DevExpress.Persistent.Base
Imports DevExpress.ExpressApp.Utils
Imports DevExpress.ExpressApp.Layout
Imports DevExpress.ExpressApp.Actions
Imports DevExpress.ExpressApp.Editors
Imports DevExpress.ExpressApp.Templates
Imports DevExpress.Persistent.Validation
Imports DevExpress.ExpressApp.SystemModule
Imports DevExpress.ExpressApp.Model.NodeGenerators
Imports Xafari.Model
Imports Xafari.Controllers
Imports Xafari
Imports System.ComponentModel

' For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/clsDevExpressExpressAppViewControllertopic.aspx.
Partial Public Class ListView_MainObj
    Inherits ViewController
    Public Sub New()
        InitializeComponent()
        ' Target required Views (via the TargetXXX properties) and create their Actions.
    End Sub
    Protected Overrides Sub OnActivated()
        MyBase.OnActivated()
        ' Perform various tasks depending on the target View.
    End Sub
    Protected Overrides Sub OnViewControlsCreated()
        MyBase.OnViewControlsCreated()
        ' Access and customize the target View control.
        'WizardAction1.Active.SetItemValue("myReason", False)
    End Sub
    Protected Overrides Sub OnDeactivated()
        ' Unsubscribe from previously subscribed events and release other references and resources.
        MyBase.OnDeactivated()
    End Sub

    Private Sub SimpleAction1_Execute(sender As Object, e As SimpleActionExecuteEventArgs) Handles SimpleAction1.Execute

        SetupWizardShowViewParameters(e.ShowViewParameters, Application.Model.Xafari().Wizards.GetWizard(WizardAction1.Id))

    End Sub

    Private poOs As DevExpress.ExpressApp.IObjectSpace = Nothing

    Private Sub SetupWizardShowViewParameters(oShowViewParameters As ShowViewParameters, oWizard As IModelWizard)

        poOs = Me.Application.CreateObjectSpace()
        Dim oEmplPerform As MainObj = poOs.GetObject(View.CurrentObject)

        Dim oController As WizardDialogController = XafariModule.CreateWizardDialogController(Me.Application)
        'oController.CanCloseWindow = False 
        'oController'oController
        AddHandler oController.Accepting, AddressOf Controller_Accepting
        AddHandler oController.Cancelling, AddressOf Controller_Cancelling
        AddHandler oController.CustomizeStepView, AddressOf Controller_CustomizeStepView
        AddHandler oController.CustomNextStep, AddressOf Controller_CustomNextStep

        oController.Model = oWizard
        oController.CurrentObject = oEmplPerform

        oShowViewParameters.Controllers.Add(oController)
        oShowViewParameters.Context = oWizard.TemplateContext
        oShowViewParameters.CreatedView = Me.Application.CreateDetailView(poOs, oWizard.Item(0).View, True, oEmplPerform)
        oShowViewParameters.TargetWindow = TargetWindow.NewModalWindow
        oShowViewParameters.NewWindowTarget = NewWindowTarget.Default

    End Sub

    Private Sub Controller_CustomNextStep(sender As Object, e As CustomNextStepEventArgs)
        
        'Dim oController As WizardDialogController = sender
        'If ctype(e.CurrentStep, IModelWizardStep).Caption = "Step 1" Then
        '    oController.CancelAction.Enabled.SetItemValue("myReason", False)
        'Else
        '    oController.CancelAction.Enabled.SetItemValue("myReason", True)
        'End If
    End Sub
    
    Private Sub Controller_CustomizeStepView(sender As Object, e As CustomizeStepViewEventArgs)
        'Dim oController As WizardDialogController = sender
        'Console.Write(CType(sender, WizardDialogController).CurrentStep.Caption)

        'If ctype(oController.CurrentStep, IModelWizardStep).Caption = "Step 1" Then
        '    oController.CancelAction.Enabled.SetItemValue("myReason", False)
        'Else
        '    oController.CancelAction.Enabled.SetItemValue("myReason", True)
        'End If

    End Sub

    Private Sub Controller_Cancelling(sender As Object, e As EventArgs)
        'poOs.Rollback
        'CType( sender,WizardDialogController).CurrentStep=CType( sender,WizardDialogController).Model.GetNode(2)
    End Sub

    Private Sub Controller_Accepting(sender As Object, e As DialogControllerAcceptingEventArgs)
        poOs.CommitChanges
        poOs.Refresh
    End Sub

End Class
