﻿Imports XafariWizardTest2.Module.ORMDataModel1
Imports Microsoft.VisualBasic
Imports System
Imports System.Linq
Imports DevExpress.ExpressApp
Imports DevExpress.Data.Filtering
Imports DevExpress.Persistent.Base
Imports DevExpress.ExpressApp.Updating
Imports DevExpress.Xpo
Imports DevExpress.ExpressApp.Xpo
Imports DevExpress.Persistent.BaseImpl

' For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/clsDevExpressExpressAppUpdatingModuleUpdatertopic.aspx
Public Class Updater
    Inherits ModuleUpdater
    Public Sub New(ByVal objectSpace As IObjectSpace, ByVal currentDBVersion As Version)
        MyBase.New(objectSpace, currentDBVersion)
    End Sub

    Public Overrides Sub UpdateDatabaseAfterUpdateSchema()
        MyBase.UpdateDatabaseAfterUpdateSchema()

        Dim name As String = "TestObj"
        Dim oMainObj As MainObj = ObjectSpace.FindObject(Of MainObj)(CriteriaOperator.Parse("Field1=?", name))
        If (oMainObj Is Nothing) Then
            oMainObj = ObjectSpace.CreateObject(Of MainObj)()
            oMainObj.Field1 = name
            oMainObj.Save
            Dim oSubObj As SubObj = ObjectSpace.CreateObject(Of SubObj)()
            oSubObj.Field1 = "Subobj"
            oSubObj.MainObj = oMainObj
            oSubObj.Save
        End If

        ObjectSpace.CommitChanges() 'Uncomment this line to persist created object(s).

    End Sub

    Public Overrides Sub UpdateDatabaseBeforeUpdateSchema()
        MyBase.UpdateDatabaseBeforeUpdateSchema()
        'If (CurrentDBVersion < New Version("1.1.0.0") AndAlso CurrentDBVersion > New Version("0.0.0.0")) Then
        '    RenameColumn("DomainObject1Table", "OldColumnName", "NewColumnName")
        'End If
    End Sub
End Class